<template lang="pug">
div {{ duration }}
</template>

<script>
export default {
  props: ["time"],
  methods: {
    zeroPad(num) {
      if (num >= 10) {
        return num;
      }
      return `0${num}`;
    },
  },
  data() {
    return {
      now: new Date(),
      timer: undefined,
    };
  },
  computed: {
    duration() {
      const milliseconds = this.time - this.now.getTime();
      const seconds = Math.floor(milliseconds / 1000);
      const minutes = Math.floor(seconds / 60);

      if (minutes <= 0 && seconds <= 0) return "0:00";

      return `${minutes}:${this.zeroPad(seconds % 60)}`;
    },
  },
  created() {
    var self = this;
    this.timer = setInterval(function () {
      self.now = new Date();
    }, 1 * 1000);
  },
  beforeDestroy() {
    clearTimeout(this.timer);
  },
};
</script>

